local mod = RW:Boss("Trash - Precious", "Icecrown Citadel", "Icecrown Citadel", "The Plagueworks")
mod:SetAsTrashMod()
local L

---------------------------
-- Variables
local mWound, tWoundDur
local tDecimateCD, tDecimateCast, wDecimate
local tZombieCD, wZombie

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Trash - Precious"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(37217)
	self:SetWin()
	
	tWoundDur		= self:DurTargetStackTimer(20, 71127)
	tDecimateCD		= self:CDTimer(33, 71123)
	tDecimateCast	= self:CastTimer(71123)
	tZombieCD		= self:CDTimer(20, 71159)
	
	wDecimate		= self:CastWarning(71123)
	wZombie			= self:CastWarning(71159)
	
	mWound			= self:TargetStackMessage(71127)
end

---------------------------
-- Locals
local zombieSpamm

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Wound", 71127)
	self:Track("Decimate", 71123)
	self:Track("Zombie", 71159)
	
	zombieSpamm = 0
end

function mod:Wound(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		tWoundDur:Start(args.dName, args.amount or 1)
		mWound:Show(args.dName, args.amount or 1)
	
	elseif event == "SPELL_AURA_REMOVED" or event == "SPELL_AURA_REMOVED_DOSE" then
		tWoundDur:Stop(args.dName)
	end
end

function mod:Decimate(event, args)
	if event == "SPELL_CAST_START" then
		tDecimateCD:Schedule(3)
		tDecimateCast:Start()
		wDecimate:Show()
	end
end

function mod:Zombie(event, args)
	if event == "SPELL_SUMMON" then
		if GetTime() - zombieSpamm > 2 then
			wZombie:Show()
			tZombieCD:Start()
			zombieSpamm = GetTime()
		end
	end
end
