local mod = RW:Boss("Kologarn", "Ulduar", "Ulduar", "The Antechamber of Ulduar")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_kologarn_01]]

---------------------------
-- Variables
local tShockwaveCD
local tFocusedEyebeamDur, wFocusedEyebeam
local tCrunchArmorDur
local tGripDur, wGrip
local tLeftRespawn, tRightRespawn

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Kologarn"
		
		L.YellPull = "None shall pass!"
		L.YellDeath = "Master, they come..."
		L.LeftArm_msg = "Left Arm respawns"
		L.LeftArm_opt = "Left Arm respawn message"
		L.RightArm_msg = "Right Arm respawns"
		L.RightArm_opt = "Right Arm respawn message"
		L.ArmRespawn_opt = "Arm respawn timers"
		L.FocusedEyebeam_target = "%s focuses his eyes on you!"

	end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 32930)
	self:SetWin(L.YellDeath, 32930)

	tShockwaveCD = self:CDTimer(18, 63982)
	tFocusedEyebeamDur, wFocusedEyebeam = self:DurTimer(11, 63976), self:RunawayWarning(63976)
	tCrunchArmorDur = self:DurTargetStackTimer(45, 64002, nil, nil, false)
	tGripDur, wGrip = self:DurTimer(15, 64290), self:CastWarning(64290)
	tLeftRespawn, tRightRespawn = self:CustomTimer(48, L.LeftArm_msg, L.LeftArm_opt, 5246, L.ArmRespawn_opt), self:CustomTimer(48, L.RightArm_msg, L.RightArm_opt, 408, L.ArmRespawn_opt)
end

---------------------------
-- Locals


---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Shockwave", 63783, 63982)
	self:Track("FocusedEyebeam", 63976, 63346)
	self:Track("CrunchArmor", 63355, 64002)
	self:Track("StoneGrip", 64290, 64292)
--  self:Track("DEATHARMSOFDOOM")	

end

function mod:Shockwave(event, args)
	if event == "SPELL_DAMAGE" then
	 	tShockwaveCD:Start()
	end
end

function mod:FocusedEyebeam(event, args)
end

function mod:CHAT_MSG_RAID_BOSS_EMOTE(event, msg, name)
	if msg == L.FocusedEyebeam_target then
		wFocusedEyebeam:Show()
	end
end


function mod:CrunchArmor(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		tCrunchArmorDur:Start(45, args.dName, args.amount or 1)
	end
end	

function mod:StoneGrip(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tGripDur:Start()
		wGrip:Show()
	end
end